/*
 *	app.h
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO 7 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
//#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	60			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

//#define TEXTURE_LIST	PAT0,PAT1,PAT2	/* eNX`Xg */
//#define TEXTURE_COUNT	3		/* eNX`̐ */
#define TEXTURE_LIST	PAT		/* eNX`Xg */
#define TEXTURE_COUNT	1		/* eNX`̐ */

void app_init();
void app_exit();
void schedule();
void espelion_main();
void text(const char* str, int x, int y, int c);
void line(int x1, int y1, int x2, int y2, int c);
void rect(int x, int y, int w, int h, int c);
void rect_fill(int x, int y, int w, int h, int c);
void sprite(fixed x, fixed y, int no);
fixed random(fixed a);
fixed random2(fixed a, fixed b);

void _setup();
void _loop();
void title_loop();
void game_loop();

typedef struct _Task Task;

void init(Task* this);
void gctrl_init(Task* this);
void bg_init(Task* this);
void ship_init(Task* this);
void info_init(Task* this);
void gauge_init(Task* this);
void enemy_init(Task* this);
void sshot_init(Task* this);
void eshot_init(Task* this);
void jwel_init(Task* this);
void bonus_init(Task* this);
void gctrl_set(Task* this);
void ship_set(Task* this, fixed px, fixed py);
void info_set(Task* this);
void gauge_set(Task* this, int max);
void enemy_set(Task* this, int num);
void enemy_set0(Task* this);
void enemy_set1(Task* this);
void enemy_set2(Task* this);
void enemy_set3(Task* this);
void enemy_set4(Task* this);
void enemy_set5(Task* this);
void enemy_set6(Task* this);
void sshot_set(Task* this, fixed px, fixed py, fixed vx, fixed vy);
void eshot_set(Task* this, fixed px, fixed py, fixed v, fixed ang);
void jwel_set(Task* this, fixed px, fixed py);
void bonus_set(Task* this, fixed px, fixed py);
void loop(Task* this);
void eval_check(Task* this);
void collision(Task* this);
void draw(Task* this);
void enemy_draw0(Task* this);
void enemy_draw1(Task* this);
void enemy_draw2(Task* this);
void enemy_draw3(Task* this);
void enemy_draw4(Task* this);
void enemy_draw5(Task* this);
void enemy_draw6(Task* this);
void gctrl_exec(Task* this);
int gctrl_seq(Task* this);
void enemy_exec(Task* this);
void enemy_exec0(Task* this);
void enemy_exec1(Task* this);
void enemy_exec2(Task* this);
void enemy_exec3(Task* this);
void enemy_exec4(Task* this);
void enemy_exec5(Task* this);
void enemy_exec6(Task* this);
void enemy_eshot(Task* this, fixed spd, int frame, fixed ang);
int collision_sub(Task* this, fixed ssx, fixed ssy, fixed sex, fixed sey, fixed dsx, fixed dsy, fixed dex, fixed dey);
void score_add(Task* this, int sc_add);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
