/*
 *	main.c
 *
 *	- ESPELION - for P/ECE
 *
 *	̃vÓAuTXԊX̕v(http://homepage2.nifty.com/isshiki/)񐧍
 *	w- ESPELION - for Proce55ingx(http://homepage2.nifty.com/isshiki/espelion/applet/)
 *	P/ECEɈڐÂłB
 *
 *	* Wed Jul 12 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Wed Jul 16 06:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	espelion_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
//#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	
 ****************************************************************************/

#define width		240	/* ʕ   */
#define height		320	/* ʍ */

#define MAP_X(x)	fist(fmul(x, fld((float)DISP_X / (float)width )))
#define MAP_Y(y)	fist(fmul(y, fld((float)DISP_Y / (float)height)))

#define ONE_SEC		FPS	/* t[[g */

#define TASK_SSHOT_NUM	12			/* e^XN */
#define TASK_ESHOT_NUM	32			/* Ge^XN */
#define TASK_ENEMY_NUM	8			/* G@^XN */
#define TASK_JWEL_NUM	(TASK_ENEMY_NUM * 4)	/* ΃^XN */
#define TASK_BONUS_NUM	TASK_ESHOT_NUM		/* ^XN */

#define JWEL_WAIT	15	/* ΌC^[o */

#define MAX_LEVEL	1000000	/* ő僌xɂȂXRA */

/* gsep_buf */
#define GSEQ_SETWAIT	0
#define GSEQ_SETTOP	1
#define GSEQ_LOOP	2
#define GSEQ_SETMAX	3
#define GSEQ_SETENE	4
#define GSEQ_WAITENE	5
#define GSEQ_STOP	254
#define GSEQ_END	255
#define GSEQ_EXIT	256

struct _Task {
	int id;		/* ^XN̎(ID_*) */
	int flag;	/* ANeButO */
	int type;	/* G@̎ */
	int step;	/* ėp? */
	int wait;	/* ėp? */
	int cnt;	/* ėp? */
	int energy;	/* G@̑ϋv */
	int jwel_max;	/* G@̕ΐ */
	Task* task;	/* GeG@ւ̊֘At */
	fixed px, py;	/* ʒu */
	fixed cx, cy;	/* 蔻 */
	fixed vx, vy;	/* ړx */
	fixed ax, ay;	/* x */
};

/* Task.id */
#define ID_GCTRL	0	/* Q[^XN */
#define ID_BG		1	/* wi^XN */
#define ID_SHIP		2	/* @^XN */
#define ID_INFO		3	/* ^XN */
#define ID_ENEMY	4	/* G@^XN */
#define ID_SSHOT	5	/* e^XN */
#define ID_ESHOT	6	/* Ge^XN */
#define ID_JWEL		7	/* ΃^XN */
#define ID_BONUS	8	/* ^XN */
#define ID_GAUGE	9	/* Q[W^XN */

Task* task_gctrl;	/* Q[^XN */
Task* task_ship;		/* @^XN */
Task* task_info;		/* ^XN */
Task* task_gauge;	/* Q[W^XN */
Task* task_bg;		/* wi^XN */
Task** task_sshot;	/* e^XN */
Task** task_eshot;	/* Ge^XN */
Task** task_enemy;	/* G@^XN */
Task** task_jwel;	/* ΃^XN */
Task** task_bonus;	/* ^XN */

int score;	/* XRA */
int high;	/* nCXRA */
int left;	/* c@ */
int extend;	/* GNXeh */

int jwel;
int jwel_cnt;
int jwel_wait;
int bonus;

fixed level;	/* x(0.0`1.0) */

int game_step;
int game_wait;

int gauge_now;	/* Q[Wl */

int gseq_pnt;	/* V[PXʒu */
int gseq_top;	/* V[PX[vJnʒu */
int gseq_loop;	/* V[PX[vc */

/* V[PXe[u(GSEQ_*) */
const int gsep_buf[] = {
	GSEQ_SETWAIT, 120,
	GSEQ_SETMAX, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_WAITENE, 0,
	GSEQ_SETMAX, 9,

	GSEQ_SETENE, 4, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETMAX, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_WAITENE, 0,
	GSEQ_SETMAX, 9,

	GSEQ_SETENE, 4, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETENE, 4, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_WAITENE, 0,
	GSEQ_SETMAX, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_WAITENE, 0,
	GSEQ_SETMAX, 1,

	GSEQ_SETENE, 5, 8,
	GSEQ_WAITENE, 0,
	GSEQ_SETWAIT, 15,

	GSEQ_WAITENE, 0,
	GSEQ_SETMAX, 8,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_SETENE, 0, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_SETENE, 1, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_SETENE, 2, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_SETTOP, 4,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_SETENE, 3, 8,
	GSEQ_WAITENE, 4,
	GSEQ_SETWAIT, 15,
	GSEQ_LOOP,

	GSEQ_WAITENE, 0,
	GSEQ_SETMAX, 1,

	GSEQ_SETENE, 6, 8,
	GSEQ_WAITENE, 0,
	GSEQ_SETWAIT, 15,

	GSEQ_SETWAIT, 60,
	GSEQ_END,
};

int shot_max;	/* eőo */
int shot_now;	/* ݂̎eo */
int shot_cnt;	/* EFCԍ */
int shot_wait;	/* tI[gC^[o */
int shot_eval;	/* 0:ʏ/1:o */

int enemy_now;	/* ݂̓G@o */
int enemy_max;	/* G@őo */

char msg[100];	/* WJp */

/****************************************************************************
 *	
 ****************************************************************************/

void espelion_main() {
	_setup();
	for(;;) {
		schedule();
		_loop();
	}
}

void text(const char* str, int x, int y, int c) {
	x = MAP_X(fild(x    ));
	y = MAP_Y(fild(y - 6));
	render_string(&render, x, y, str, 0x82, c);
}

void line(int x1, int y1, int x2, int y2, int c) {
	x1 = MAP_X(fild(x1));
	y1 = MAP_Y(fild(y1));
	x2 = MAP_X(fild(x2));
	y2 = MAP_Y(fild(y2));
	render_line(&render, x1, y1, x2, y2, c);
}

void rect(int x, int y, int w, int h, int c) {
	x = MAP_X(fild(x));
	y = MAP_Y(fild(y));
	w = MAP_X(fild(w));
	h = MAP_Y(fild(h));
	render_rectangle(&render, x, y, w, h, c);
}

void rect_fill(int x, int y, int w, int h, int c) {
	x = MAP_X(fild(x));
	y = MAP_Y(fild(y));
	w = MAP_X(fild(w));
	h = MAP_Y(fild(h));
	render_rectangle_fill(&render, x, y, w, h, c);
}

void sprite(fixed x, fixed y, int no) {
	sprite_draw(MAP_X(x), MAP_Y(y), no, 0);
}

fixed random(fixed a) {
	fixed r = (fixed)(rand() & FRACT_MASK);
	r = fmul(r, a);
	return r;
}

fixed random2(fixed a, fixed b) {
	fixed r = random(fsub(b, a));
	r = fadd(r, a);
	return r;
}

void _setup() {
	int i;

	/* Q[^XN쐬B */
	task_gctrl = calloc(1, sizeof(Task));
	init(task_gctrl);
	gctrl_init(task_gctrl);

	/* @^XN쐬B */
	task_ship = calloc(1, sizeof(Task));
	init(task_ship);
	ship_init(task_ship);

	/* ^XN쐬B */
	task_info = calloc(1, sizeof(Task));
	init(task_info);
	info_init(task_info);

	/* Q[W\^XN쐬B */
	task_gauge = calloc(1, sizeof(Task));
	init(task_gauge);
	gauge_init(task_gauge);

	/* wi^XN쐬B */
	task_bg = calloc(1, sizeof(Task));
	init(task_bg);
	bg_init(task_bg);

	/* e^XN쐬B */
	task_sshot = calloc(TASK_SSHOT_NUM, sizeof(Task*));
	for (i = 0; i < TASK_SSHOT_NUM; i++) {
		task_sshot[i] = calloc(1, sizeof(Task));
		init(task_sshot[i]);
		sshot_init(task_sshot[i]);
	}

	/* Ge^XN쐬B */
	task_eshot = calloc(TASK_ESHOT_NUM, sizeof(Task*));
	for (i = 0; i < TASK_ESHOT_NUM; i++) {
		task_eshot[i] = calloc(1, sizeof(Task));
		init(task_eshot[i]);
		eshot_init(task_eshot[i]);
	}

	/* G@^XN쐬 */
	task_enemy = calloc(TASK_ENEMY_NUM, sizeof(Task*));
	for (i = 0; i < TASK_ENEMY_NUM; i++) {
		task_enemy[i] = calloc(1, sizeof(Task));
		init(task_enemy[i]);
		enemy_init(task_enemy[i]);
	}

	/* ΃^XN쐬B */
	task_jwel = calloc(TASK_JWEL_NUM, sizeof(Task*));
	for (i = 0; i < TASK_JWEL_NUM; i++) {
		task_jwel[i] = calloc(1, sizeof(Task));
		init(task_jwel[i]);
		jwel_init(task_jwel[i]);
	}

	/* ^XN쐬B */
	task_bonus = calloc(TASK_BONUS_NUM, sizeof(Task*));
	for (i = 0; i < TASK_BONUS_NUM; i++) {
		task_bonus[i] = calloc(1, sizeof(Task));
		init(task_bonus[i]);
		bonus_init(task_bonus[i]);
	}

	/* nCXRAB */
	high = 0;

	/* Q[ԏB */
	game_step = 0;
}

void _loop() {
	int i;

	/* wiB */
	memset(vbuff, 0, sizeof vbuff);

	switch (game_step) {
	/* ^Cg */
	case 0:
		title_loop();
		text("CLICK START", width / 2 - 58, height / 2, 2);
		break;
	/* Q[Jn */
	case 1:
		/* Q[^XNJnB */
		gctrl_set(task_gctrl);
		/* @^XNJnB */
		ship_set(task_ship, fild(width / 2), fild(height - 32));
		/* ^XNJnB */
		info_set(task_info);
		/* Q[ԂցB */
		game_step++;
		break;
	/* Q[ */
	case 2:
		game_loop();
		break;
	/* Q[I[o[ */
	case 3:
		text("GAME OVER", width / 2 - 48, height / 2, 2);
		/* FALLTHRU */
	/* Q[I */
	case 4:
		if (game_wait != 0) {
			game_wait--;
			game_loop();
		} else {
			/* Q[ԏB */
			game_step = 0;
			/* Q[^XNB */
			init(task_gctrl);
			gctrl_init(task_gctrl);
			/* @^XNB */
			init(task_ship);
			ship_init(task_ship);
			/* ^XNB */
			init(task_info);
			info_init(task_info);
			/* Q[W^XNB */
			init(task_gauge);
			gauge_init(task_gauge);
			/* e^XNB */
			for (i = 0; i < TASK_SSHOT_NUM; i++) {
				init(task_sshot[i]);
				sshot_init(task_sshot[i]);
			}
			/* Ge^XNB */
			for (i = 0; i < TASK_ESHOT_NUM; i++) {
				init(task_eshot[i]);
				eshot_init(task_eshot[i]);
			}
			/* G@^XNB */
			for (i = 0; i < TASK_ENEMY_NUM; i++) {
				init(task_enemy[i]);
				enemy_init(task_enemy[i]);
			}
			/* ΃^XNB */
			for (i = 0; i < TASK_JWEL_NUM; i++) {
				init(task_jwel[i]);
				jwel_init(task_jwel[i]);
			}
			/* ^XNB */
			for (i = 0; i < TASK_BONUS_NUM; i++) {
				init(task_bonus[i]);
				bonus_init(task_bonus[i]);
			}
		}
		break;
	}
}

void title_loop() {
	/* wi^XNB */
	loop(task_bg);
	draw(task_bg);

	/* nCXRA\B */
	sprintf(msg, "HIGH %d", high);
	text(msg, 12, 16, 2);

	/* A܂B{^ꂽQ[JnB */
	if (joy & TRG_AB) {
		game_step++;
	}

	/* SELECT{^ꂽQ[IB */
	if (joy & TRG_SELECT) {
		exit(0);
	}
}

void game_loop() {
	int i;

	/* Q[^XNB */
	loop(task_gctrl);

	/* wi^XNB */
	loop(task_bg);
	draw(task_bg);

	/* e^XNB */
	for (i = 0; i < TASK_SSHOT_NUM; i++) {
		loop(task_sshot[i]);
		collision(task_sshot[i]);
		draw(task_sshot[i]);
	}

	/* G@^XNB */
	for (i = 0; i < TASK_ENEMY_NUM; i++) {
		loop(task_enemy[i]);
		collision(task_enemy[i]);
		draw(task_enemy[i]);
	}

	/* @^XNB */
	loop(task_ship);
	draw(task_ship);

	/* ΃^XNB */
	for (i = 0; i < TASK_JWEL_NUM; i++) {
		loop(task_jwel[i]);
		collision(task_jwel[i]);
		draw(task_jwel[i]);
	}

	/* ^XNB */
	for (i = 0; i < TASK_BONUS_NUM; i++) {
		loop(task_bonus[i]);
		collision(task_bonus[i]);
		draw(task_bonus[i]);
	}

	/* Ge^XNB */
	for (i = 0; i < TASK_ESHOT_NUM; i++) {
		loop(task_eshot[i]);
		collision(task_eshot[i]);
		draw(task_eshot[i]);
	}

	/* ^XNB */
	loop(task_info);
	draw(task_info);

	/* Q[W^XNB */
	loop(task_gauge);
	draw(task_gauge);
}

void init(Task* this) {
	this->id = 0;
	this->flag = 0;
	this->vx = fild(0);
	this->vy = fild(0);
	this->cx = fild(0);
	this->cy = fild(0);
	this->step = 0;
	this->wait = 0;
	this->task = NULL;
}

void gctrl_init(Task* this) {
	this->id = ID_GCTRL;
	score = 0;
	left = 3;
	extend = 0;
	jwel = 100;
	jwel_cnt = 0;
	jwel_wait = 0;
	bonus = 0;
	level = fild(0);
}

void bg_init(Task* this) {
	this->id = ID_BG;
	this->px = fild(0);
	this->py = fild(0);
}

void ship_init(Task* this) {
	this->id = ID_SHIP;
	this->cx = fild(2);
	this->cy = fild(2);
}

void info_init(Task* this) {
	this->id = ID_INFO;
}

void gauge_init(Task* this) {
	this->id = ID_GAUGE;
}

void enemy_init(Task* this) {
	this->id = ID_ENEMY;
}

void sshot_init(Task* this) {
	this->id = ID_SSHOT;
	this->cx = fild(4);
	this->cy = fild(8);
}

void eshot_init(Task* this) {
	this->id = ID_ESHOT;
	this->cx = fild(2);
	this->cy = fild(2);
}

void jwel_init(Task* this) {
	this->id = ID_JWEL;
	this->cx = fild(12);
	this->cy = fild(16);
}

void bonus_init(Task* this) {
	this->id = ID_BONUS;
	this->cx = fild(12);
	this->cy = fild(12);
}

void gctrl_set(Task* this) {
	this->flag = 1;
	enemy_now = 0;
	enemy_max = 0;
}

void ship_set(Task* this, fixed px, fixed py) {
	this->px = px;
	this->py = py;
	this->flag = 1;
	shot_max = TASK_SSHOT_NUM;
	shot_now = 0;
	shot_cnt = 0;
	shot_wait = 0;
	shot_eval = 0;
}

void info_set(Task* this) {
	this->flag = 1;
}

void gauge_set(Task* this, int max) {
	this->flag = 1;
	this->cnt = max;
	gauge_now = 0;
}

void enemy_set(Task* this, int num) {
	this->step = 0;
	this->flag = 1;
	this->cnt = 0;
	this->wait = 0;
	this->type = num;
	this->cx = fild(8);
	this->cy = fild(8);
	switch (this->type) {
	case 0:
		enemy_set0(this);
		break;
	case 1:
		enemy_set1(this);
		break;
	case 2:
		enemy_set2(this);
		break;
	case 3:
		enemy_set3(this);
		break;
	case 4:
		enemy_set4(this);
		break;
	case 5:
		enemy_set5(this);
		gauge_set(task_gauge, this->energy);
		break;
	case 6:
		enemy_set6(this);
		gauge_set(task_gauge, this->energy);
		break;
	}
}

void enemy_set0(Task* this) {
	this->px = fiadd(random(fild(width - 16)), 8);
	this->py = fild(-8);
	this->vy = fild( 3);
	this->energy = 1;
	this->jwel_max = this->energy * 2;
}

void enemy_set1(Task* this) {
	this->px = fiadd(random(fild(width - 16)), 8);
	this->py = fild(-8);
	if (ficom(this->px, >, width / 2)) {
		this->vx = fidiv(fchs(fadd(random(fild(1)), fld(0.5))), 2);
	} else {
		this->vx = fidiv(     fadd(random(fild(1)), fld(0.5)) , 2);
	}
	this->vy = fild(2);
	this->energy = 2;
	this->jwel_max = this->energy * 2;
}

void enemy_set2(Task* this) {
	this->px = fiadd(random(fild(width - 16)), 8);
	this->py = fiadd(random(fild(80)), 32);
	if (ficom(this->px, >, width / 2)) {
		this->px = fild(width + 8);
		this->vx = fidiv(fchs(fiadd(random(fild(3)), 2)), 2);
	} else {
		this->px = fild(    0 - 8);
		this->vx = fidiv(     fiadd(random(fild(3)), 2) , 2);
	}
	this->vy = fild(0);
	this->energy = 2;
	this->jwel_max = this->energy * 2;
}

void enemy_set3(Task* this) {
	this->px = fiadd(random(fild(width - 16)), 8);
	this->py = fild(-8);
	if (ficom(this->px, >, width / 2)) {
		this->vx = fidiv(fchs(fadd(random(fild(1)), fld(0.5))), 2);
		this->ax = fld(-0.015);
	} else {
		this->vx = fidiv(     fadd(random(fild(1)), fld(0.5)) , 2);
		this->ax = fld( 0.015);
	}
	this->vy = fild(2);
	this->ay = fld(0.015);
	this->energy = 1;
	this->jwel_max = this->energy * 2;
}

void enemy_set4(Task* this) {
	this->cx = fild(16);
	this->cy = fild(16);
	this->px = fiadd(random(fild(width - 64)), 32);
	this->py = fild(-16);
	this->vx = fild(0);
	this->vy = fld(0.55);
	this->energy = 80;
	this->jwel_max = this->energy * 2;
}

void enemy_set5(Task* this) {
	this->cx = fild(32);
	this->cy = fild(32);
	this->px = fild(width / 2);
	this->py = fild(-32);
	this->vx = fild(0);
	this->vy = fild(0);
	this->ax = fild(width / 2);
	this->ay = fild(height / 2 - 32);
	this->energy = 240;
	this->jwel_max = this->energy;
}

void enemy_set6(Task* this) {
	this->cx = fild(64);
	this->cy = fild(48);
	this->px = fild(width / 2);
	this->py = fild(-32);
	this->vx = fild(0);
	this->vy = fild(0);
	this->ax = fild(width / 2);
	this->ay = fild(height / 2 - 32);
	this->energy = 500;
	this->jwel_max = this->energy;
}

void sshot_set(Task* this, fixed px, fixed py, fixed vx, fixed vy) {
	this->flag = 1;
	this->px = px;
	this->py = py;
	this->vx = vx;
	this->vy = vy;
}

void eshot_set(Task* this, fixed px, fixed py, fixed v, fixed ang) {
	fixed a;
	this->flag = 1;
	this->px = px;
	this->py = py;
	a = fatan2(fsub(task_ship->px, px), fsub(py, task_ship->py));
	a = fadd(a, random2(fchs(ang), ang));
	this->vx = fmul(fsin(a),      v );
	this->vy = fmul(fcos(a), fchs(v));
}

void jwel_set(Task* this, fixed px, fixed py) {
	this->flag = 1;
	this->px = px;
	this->py = py;
	this->vx = fadd(px, fisub(random(fild(16)),  8));
	this->vy = fsub(py, fiadd(random(fild(32)), 16));
	this->wait = 30; 
}

void bonus_set(Task* this, fixed px, fixed py) {
	this->flag = 1;
	this->px = px;
	this->py = py;
	this->wait = 30; 
}

void loop(Task* this) {
	int i;
	int spd;
	int dir;
	fixed d;

	/* wi^XN */
	if (this->id == ID_BG) {
		this->px = fadd(this->px, fld(0.1));
		this->py = fadd(this->py, fld(1.0));
		if (ficom(this->px, >, 24)) this->px = fisub(this->px, 24);
		if (ficom(this->py, >, 32)) this->py = fisub(this->py, 32);
	}
	/* Q[^XN */
	if (this->id == ID_GCTRL && this->flag == 1) {
		gctrl_exec(this);
	}
	/* @^XN */
	if (this->id == ID_SHIP && this->flag == 1) {
		if (this->wait > ONE_SEC) { /* X^[g`G */
			this->wait--;
			if (this->wait == ONE_SEC) {
				this->px = fild(width / 2);
				this->py = fild(height - 32);
				shot_eval = 0;
			}
		} else if (this->wait > 0) { /* G`G */
			this->wait--;
		} else /* this->wait == 0 */ { /* ʏ */
			/** no job **/
		}
		/*{{@ړ*/
		spd = 3/**/;
		if(joy & PAD_RI) {
			if(joy & PAD_UP) {
				dir = 7;
			} else if(joy & PAD_DN) {
				dir = 1;
			} else {
				dir = 0;
			}
		} else if(joy & PAD_LF) {
			if(joy & PAD_UP) {
				dir = 5;
			} else if(joy & PAD_DN) {
				dir = 3;
			} else {
				dir = 4;
			}
		} else {
			if(joy & PAD_UP) {
				dir = 6;
			} else if(joy & PAD_DN) {
				dir = 2;
			} else {
				dir = -1;
			}
		}
		if(dir != -1) {
			d = fidiv(fimul(PI2, dir), 8);
			this->px = fadd(this->px, fimul(fcos(d), spd));
			this->py = fadd(this->py, fimul(fsin(d), spd));
		}
		/*}}@ړ*/
		if (this->wait <= ONE_SEC) {
			eval_check(this);
			if (shot_wait != 0) shot_wait--;
			if ((shot_wait == 0) && (joy & PAD_B)) {
				shot_wait = 4;
				if (!shot_eval) { /* ʏ */
					if ((shot_now + 3) <= shot_max) {
						shot_cnt = 3;
						for (i = 0; i < TASK_SSHOT_NUM; i++) {
							if (task_sshot[i]->flag == 0) {
								if (shot_cnt == 3) sshot_set(task_sshot[i], fisub(this->px,6), this->py, fild(0), fild(-8));
								if (shot_cnt == 2) sshot_set(task_sshot[i],       this->px   , this->py, fild(0), fild(-8));
								if (shot_cnt == 1) sshot_set(task_sshot[i], fiadd(this->px,6), this->py, fild(0), fild(-8));
								shot_now++;
								shot_cnt--;
								if (shot_cnt == 0) break;
							}
						}
					}
				} else { /* o */
					if ((shot_now + 2) <= shot_max) {
						shot_cnt = 2;
						for (i = 0; i < TASK_SSHOT_NUM; i++) {
							if (task_sshot[i]->flag == 0) {
								if (shot_cnt == 2) sshot_set(task_sshot[i], fisub(this->px,3), this->py, fild(0), fild(-8));
								if (shot_cnt == 1) sshot_set(task_sshot[i], fiadd(this->px,3), this->py, fild(0), fild(-8));
								shot_now++;
								shot_cnt--;
								if (shot_cnt == 0) break;
							}
						}
					}
				}
			}
			/* oȂ΁A6t[ɕΌB */
			if (shot_eval) {
				jwel_cnt++;
				if ((jwel_cnt % 6) == 0) {
					if (jwel != 0) jwel--;
				}
			}
			/* ΂cĂAxJWEL_WAITt[ɋ򌸏B */
			if (jwel != 0) {
				jwel_wait--;
				if (jwel_wait < 0) {
					if ((jwel_wait % JWEL_WAIT) == 0 && bonus > 0) bonus -= 10;
				}
			}
		}
		if (ficom(this->px, <,          12)) this->px = fild(         12);
		if (ficom(this->px, >, width  - 12)) this->px = fild(width  - 12);
		if (ficom(this->py, <,          16)) this->py = fild(         16);
		if (ficom(this->py, >, height - 12)) this->py = fild(height - 12);
	}
	/* G@^XN */
	if (this->id == ID_ENEMY && this->flag == 1) {
		enemy_exec(this);
		this->px = fadd(this->px, this->vx);
		this->py = fadd(this->py, this->vy);
		if (ficom(this->py, >, height + 8) || ficom(this->px, <, -8) || ficom(this->px, >, width + 8)){
			this->flag = 0;
			enemy_now--;
		}
	}
	/* e^XN */
	if (this->id == ID_SSHOT && this->flag == 1) {
		this->px = fadd(this->px, this->vx);
		this->py = fadd(this->py, this->vy);
		if (ficom(this->py, <, -16)){
			this->flag = 0;
			shot_now--;
		}
	}
	/* Ge^XN */
	if (this->id == ID_ESHOT && this->flag == 1) {
		if (shot_eval) { /* o */
			if (jwel != 0) {
				this->px = fadd(this->px, fidiv(this->vx, 2));
				this->py = fadd(this->py, fidiv(this->vy, 2));
			} else {
				this->px = fadd(this->px, fmul(this->vx, fld(1.5)));
				this->py = fadd(this->py, fmul(this->vy, fld(1.5)));
			}
		} else {
			/* ʏ */
			this->px = fadd(this->px, this->vx);
			this->py = fadd(this->py, this->vy);
		}
		if (ficom(this->py, <, -4) || ficom(this->py, >, height + 4) || ficom(this->px, <, -4) || ficom(this->px, >, width + 4)){
			this->flag = 0;
		}
	}
	/* ΃^XN */
	if (this->id == ID_JWEL && this->flag == 1) {
		if (this->wait != 0) {
			this->wait--;
			this->px = fadd(this->px, fidiv(fsub(this->vx, this->px), 5));
			this->py = fadd(this->py, fidiv(fsub(this->vy, this->py), 5));
		} else {
			this->px = fadd(this->px, fidiv(fsub(task_ship->px, this->px), 15));
			this->py = fadd(this->py, fidiv(fsub(task_ship->py, this->py), 15));
		}
	}
	/* ^XN */
	if (this->id == ID_BONUS && this->flag == 1) {
		if (this->wait != 0) {
			this->wait--;
		} else {
			this->px = fadd(this->px, fidiv(fsub(task_ship->px, this->px), 15));
			this->py = fadd(this->py, fidiv(fsub(task_ship->py, this->py), 15));
		}
	}
	/* Q[W^XN */
	if (this->id == ID_GAUGE && this->flag == 1) {
		if (gauge_now < 1) {
			this->flag = 0;
		}
	}
}

void eval_check(Task* this) {
	/* ʏ̊oؑցB */
	if (joy & TRG_A) {
		shot_eval = !shot_eval;
	}
}

void collision(Task* this) {
	int i,j,k;
	fixed ssx,ssy,sex,sey;
	fixed dsx,dsy,dex,dey;
	/* G@̎@ */
	if (this->id == ID_ENEMY && this->flag == 1 && task_ship->flag == 1 && task_ship->wait == 0) {
		ssx = fsub(this->px, this->cx);
		sex = fadd(this->px, this->cx);
		ssy = fsub(this->py, this->cy);
		sey = fadd(this->py, this->cy);
		dsx = fsub(task_ship->px, task_ship->cx);
		dex = fadd(task_ship->px, task_ship->cx);
		dsy = fsub(task_ship->py, task_ship->cy);
		dey = fadd(task_ship->py, task_ship->cy);
		if (collision_sub(this, ssx, ssy, sex, sey, dsx, dsy, dex, dey) != 0) {
			left--;
			if (left < 0) {
				left = 0;
				task_ship->flag = 0;
				game_step = 3;
				game_wait = ONE_SEC * 3;
			} else {
				task_ship->wait = ONE_SEC * 2; /* \1b{G1b */
			}
		}
	}
	/* e̓G@ */
	if (this->id == ID_SSHOT && this->flag == 1) {
		ssx = fsub(this->px, this->cx);
		sex = fadd(this->px, this->cx);
		ssy = fsub(this->py, this->cy);
		sey = fadd(this->py, this->cy);
		for (i = 0; i < TASK_ENEMY_NUM; i++) {
			if (task_enemy[i]->flag == 1) {
				dsx = fsub(task_enemy[i]->px, task_enemy[i]->cx);
				dex = fadd(task_enemy[i]->px, task_enemy[i]->cx);
				dsy = fsub(task_enemy[i]->py, task_enemy[i]->cy);
				dey = fadd(task_enemy[i]->py, task_enemy[i]->cy);
				if (collision_sub(this, ssx, ssy, sex, sey, dsx, dsy, dex, dey) != 0) {
					this->flag = 0;
					shot_now--;
					task_enemy[i]->energy--;
					if (task_enemy[i]->energy < 0) {
						task_enemy[i]->flag = 0;
						if (!shot_eval) {
							/* ʏȂ΁A΂𐶐B */
							for (j = 0; j < task_enemy[i]->jwel_max; j++) {
								for (k = 0; k < TASK_JWEL_NUM; k++) {
									if (task_jwel[k]->flag == 0) {
										jwel_set(task_jwel[k], task_enemy[i]->px, task_enemy[i]->py);
										break;
									}
								}
							}
						} else {
							if (jwel != 0) {
								/* oEΗLȂ΁A̓GGeɕς܂B */
								jwel -= task_enemy[i]->jwel_max;
								if (jwel < 0) jwel = 0;
								for (j = 0; j < TASK_ESHOT_NUM; j++) {
									if (task_eshot[j]->flag == 1 && task_eshot[j]->task == task_enemy[i]) {
										task_eshot[j]->flag = 0;
										for (k = 0; k < TASK_BONUS_NUM; k++) {
											if (task_bonus[k]->flag == 0) {
												bonus_set(task_bonus[k], task_eshot[j]->px, task_eshot[j]->py);
												break;
											}
										}
									}
								}
							} else {
								/* oEΖȂ΁A𐶐B */
								for (j = 0; j < task_enemy[i]->jwel_max; j++) {
									for (k = 0; k < TASK_BONUS_NUM; k++) {
										if (task_bonus[k]->flag == 0) {
											bonus_set(task_bonus[k], this->px, this->py);
											break;
										}
									}
								}
							}
						}
						enemy_now--;
						score_add(this, 10);
					}
				}
			}
		}
	}
	/* Ge̎@ */
	if (this->id == ID_ESHOT && this->flag == 1 && task_ship->flag == 1 && task_ship->wait == 0) {
		ssx = fsub(this->px, this->cx);
		sex = fadd(this->px, this->cx);
		ssy = fsub(this->py, this->cy);
		sey = fadd(this->py, this->cy);
		dsx = fsub(task_ship->px, task_ship->cx);
		dex = fadd(task_ship->px, task_ship->cx);
		dsy = fsub(task_ship->py, task_ship->cy);
		dey = fadd(task_ship->py, task_ship->cy);
		if (collision_sub(this, ssx, ssy, sex, sey, dsx, dsy, dex, dey) != 0) {
			left--;
			if (left < 0) {
				left = 0;
				task_ship->flag = 0;
				game_step = 3;
				game_wait = ONE_SEC * 3;
			} else {
				task_ship->wait = ONE_SEC * 2; /* \1b{G1b */
			}
		}
	}
	/* ΁̎@ */
	if (this->id == ID_JWEL && this->flag == 1 && task_ship->flag == 1) {
		ssx = fsub(this->px, this->cx);
		sex = fadd(this->px, this->cx);
		ssy = fsub(this->py, this->cy);
		sey = fadd(this->py, this->cy);
		dsx = fsub(task_ship->px, task_ship->cx);
		dex = fadd(task_ship->px, task_ship->cx);
		dsy = fsub(task_ship->py, task_ship->cy);
		dey = fadd(task_ship->py, task_ship->cy);
		if (collision_sub(this, ssx, ssy, sex, sey, dsx, dsy, dex, dey) != 0) {
			this->flag = 0;
			if (jwel < 500) {
				jwel++;
			} else {
				score_add(this, 10);
			}
		}
	}
	/* ̎@ */
	if (this->id == ID_BONUS && this->flag == 1 && task_ship->flag == 1) {
		ssx = fsub(this->px, this->cx);
		sex = fadd(this->px, this->cx);
		ssy = fsub(this->py, this->cy);
		sey = fadd(this->py, this->cy);
		dsx = fsub(task_ship->px, task_ship->cx);
		dex = fadd(task_ship->px, task_ship->cx);
		dsy = fsub(task_ship->py, task_ship->cy);
		dey = fadd(task_ship->py, task_ship->cy);
		if (collision_sub(this, ssx, ssy, sex, sey, dsx, dsy, dex, dey) != 0) {
			if (bonus < 1000) {
				bonus += 10;
			}
			this->flag = 0;
			score_add(this, bonus);
			if (jwel_wait < 0) jwel_wait = 0;
			jwel_wait += JWEL_WAIT;
		}
	}
}

void draw(Task* this) {
	int i;

	if (this->id == ID_BG) {
		int add_x = 0;
		int add_y = 0;
		for (i = 0; i < 10; i++) {
			line(0, fist(this->py) + add_y, width, fist(this->py) + add_y, 1);
			add_y += 32;
		}
		for (i = 0; i < 10; i++) {
			line(fist(this->px) + add_x, 0, fist(this->px) + add_x, height, 1);
			add_x += 24;
		}
	}
	if (this->id == ID_SHIP && this->flag == 1 && this->wait <= ONE_SEC) {
		if (shot_eval) {
			sprite(this->px, this->py, SPR_SHIP1);
		} else {
			sprite(this->px, this->py, SPR_SHIP0);
		}
	}
	if (this->id == ID_INFO && this->flag == 1) {
		sprintf(msg, "SC %d", score);
		text(msg, 12, 16, 2);
		sprintf(msg, "HI %d", high);
		text(msg, width - 112, 16, 2);
		sprintf(msg, "JWEL %d / %d", jwel, bonus);
		text(msg, 12, 30, 2);
		sprintf(msg, "LEFT %d", left);
		text(msg, 12, height - 12, 2);
	}
	if (this->id == ID_GAUGE && this->flag == 1) {
		int wx;
		rect(8, 42, 224, 12, 3);
		wx = 222 * gauge_now / this->cnt;
		rect_fill(9, 43, wx, 10, 2);
	}
	if (this->id == ID_ENEMY && this->flag == 1) {
		switch (this->type) {
		case 0:
			enemy_draw0(this);
			break;
		case 1:
			enemy_draw1(this);
			break;
		case 2:
			enemy_draw2(this);
			break;
		case 3:
			enemy_draw3(this);
			break;
		case 4:
			enemy_draw4(this);
			break;
		case 5:
			enemy_draw5(this);
			break;
		case 6:
			enemy_draw6(this);
			break;
		}
	}
	if (this->id == ID_SSHOT && this->flag == 1) {
		sprite(this->px, this->py, SPR_SSHOT);
	}
	if (this->id == ID_ESHOT && this->flag == 1) {
		if (shot_eval) {
			if (jwel != 0) {
				sprite(this->px, this->py, SPR_ESHOT1);
			} else {
				sprite(this->px, this->py, SPR_ESHOT2);
			}
		} else {
			sprite(this->px, this->py, SPR_ESHOT0);
		}
	}
	if (this->id == ID_JWEL && this->flag == 1) {
		sprite(this->px, this->py, SPR_JWEL);
	}
	if (this->id == ID_BONUS && this->flag == 1) {
		sprite(this->px, this->py, SPR_BONUS);
	}
}

void enemy_draw0(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY0);
}

void enemy_draw1(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY1);
}

void enemy_draw2(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY2);
}

void enemy_draw3(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY3);
}

void enemy_draw4(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY4);
}

void enemy_draw5(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY5);
}

void enemy_draw6(Task* this) {
	sprite(this->px, this->py, SPR_ENEMY6);
}

void gctrl_exec(Task* this) {
	int ret;
	if (this->wait != 0) {
		this->wait--;
	} else {
		switch (this->step) {
		case 0: /* Q[Jn */
			gseq_pnt = 0;
			this->step++;
			break;
		case 1: /* Q[ */
			while ((ret = gctrl_seq(this)) == 0);
			if (ret == -1) { /* V[PXI(X{XԐ؂?) */
				this->step++;
			}
			break;
		case 2: /* X{Xj? */
			game_wait = 60;
			game_step = 4;
			this->step++;
		default:
			break;
		}
	}
}

int gctrl_seq(Task* this) {
	int ret = 0;
	int i;
	switch (gsep_buf[gseq_pnt]) {
	case GSEQ_SETWAIT:
		this->wait = gsep_buf[gseq_pnt + 1];
		gseq_pnt += 2;
		ret = 1;
		break;
	case GSEQ_SETTOP:
		gseq_loop = gsep_buf[gseq_pnt + 1];
		gseq_pnt += 2;
		gseq_top = gseq_pnt;
		break;
	case GSEQ_LOOP:
		if (gseq_loop != 0) {
			gseq_loop--;
			gseq_pnt = gseq_top;
		} else {
			gseq_pnt += 1;
		}
		ret = 1;
		break;
	case GSEQ_SETMAX:
		enemy_max = gsep_buf[gseq_pnt + 1];
		gseq_pnt += 2;
		break;
	case GSEQ_SETENE:
		if (enemy_now < enemy_max) {
			for (i = 0; i < TASK_ENEMY_NUM; i++) {
				if (task_enemy[i]->flag == 0) {
					enemy_set(task_enemy[i], gsep_buf[gseq_pnt + 1]);
					enemy_now++;
					this->wait = gsep_buf[gseq_pnt + 2];
					gseq_pnt += 3;
					break;
				}
			}
		}
		ret = 1;
		break;
	case GSEQ_WAITENE:
		if (enemy_now <= gsep_buf[gseq_pnt + 1]) {
			gseq_pnt += 2;
		}
		ret = 1;
		break;
	case GSEQ_STOP:
		ret = 1;
		break;
	case GSEQ_END:
		ret = -1;
		break;
	case GSEQ_EXIT:
		ret = -1;
		break;
	default:
		ret = -1;
		break;
	}
	return	ret;
}

void enemy_exec(Task* this) {
	switch (this->type) {
	case 0:
		enemy_exec0(this);
		break;
	case 1:
		enemy_exec1(this);
		break;
	case 2:
		enemy_exec2(this);
		break;
	case 3:
		enemy_exec3(this);
		break;
	case 4:
		enemy_exec4(this);
		break;
	case 5:
		enemy_exec5(this);
		break;
	case 6:
		enemy_exec6(this);
		break;
	}
}

void enemy_exec0(Task* this) {
	switch (this->step) {
	case 0:
		this->cnt = ONE_SEC;
		this->step++;
		break;
	case 1:
		if (this->cnt != 0) {
			this->cnt--;
		} else {
			this->step++;
		}
		this->vy = fadd(this->vy, fidiv(fsub(fild(1), this->vy), ONE_SEC / 2));
		enemy_eshot(this, fild(1), 60, fild(0));
		break;
	case 2:
		this->vy = fadd(this->vy, fidiv(fsub(fild(3), this->vy), ONE_SEC));
		enemy_eshot(this, fild(1), 60, fild(0));
		break;
	default:
		break;
	}
}

void enemy_exec1(Task* this) {
	switch (this->step) {
	case 0:
		this->step++;
		break;
	case 1:
		enemy_eshot(this, fild(1),  0, fld(0.01));
		enemy_eshot(this, fild(1), 60, fld(0.01));
		break;
	default:
		break;
	}
}

void enemy_exec2(Task* this) {
	switch (this->step) {
	case 0:
		this->step++;
		break;
	case 1:
		enemy_eshot(this, fld(1.5),  0, fld(0.025));
		enemy_eshot(this, fld(1.5),  0, fld(0.025));
		enemy_eshot(this, fld(1.5), 90, fld(0.025));
		break;
	default:
		break;
	}
}

void enemy_exec3(Task* this) {
	switch (this->step) {
	case 0:
		this->step++;
		break;
	case 1:
		this->vx = fadd(this->vx, this->ax);
		this->vy = fadd(this->vy, this->ay);
		enemy_eshot(this, fild(1),  0, fld(0.05));
		enemy_eshot(this, fild(1), 45, fld(0.05));
		break;
	default:
		break;
	}
}

void enemy_exec4(Task* this) {
	switch (this->step) {
	case 0:
		this->step++;
		this->cnt = 240;
		break;
	case 1:
		if (this->cnt != 0) {
			this->cnt--;
		} else {
			this->vx = fild(0);
			this->vy = fild(0);
			this->step++;
		}
		break;
	case 2:
		enemy_eshot(this, fild(1),  0, fld(0.1));
		enemy_eshot(this, fild(1), 45, fld(0.1));
		break;
	default:
		break;
	}
}

void enemy_exec5(Task* this) {
	gauge_now = this->energy;
	if (gauge_now < 0) gauge_now = 0;
	switch (this->step) {
	case 0:
		this->step++;
		this->cnt = 30;
		break;
	case 1:
		if (this->cnt != 0) {
			this->cnt--;
			this->px = fadd(this->px, fidiv(fsub(this->ax, this->px), 15));
			this->py = fadd(this->py, fidiv(fsub(this->ay, this->py), 15));
		} else {
			this->step++;
		}
		break;
	case 2:
		enemy_eshot(this, fild(2),  0, fld(0.25));
		enemy_eshot(this, fild(2),  0, fld(0.25));
		enemy_eshot(this, fild(2),  0, fld(0.25));
		enemy_eshot(this, fild(2), 45, fld(0.25));
		break;
	default:
		break;
	}
}

void enemy_exec6(Task* this) {
	gauge_now = this->energy;
	if (gauge_now < 0) gauge_now = 0;
	switch (this->step) {
	case 0:
		this->step++;
		this->cnt = 30;
		break;
	case 1:
		if (this->cnt != 0) {
			this->cnt--;
			this->px = fadd(this->px, fidiv(fsub(this->ax, this->px), 15));
			this->py = fadd(this->py, fidiv(fsub(this->ay, this->py), 15));
		} else {
			this->step++;
			this->cnt = ONE_SEC * 5;
		}
		break;
	case 2:
		if (this->cnt != 0) {
			this->cnt--;
			enemy_eshot(this, fild(5), 5, fld(0.05));
		} else {
			this->cnt = ONE_SEC;
			this->step++;
		}
		break;
	case 3:
		if (this->cnt != 0) {
			this->cnt--;
		} else {
			this->cnt = ONE_SEC * 5;
			this->step++;
		}
		break;
	case 4:
		if (this->cnt != 0) {
			this->cnt--;
			enemy_eshot(this, fild(1),  0, fld(0.5));
			enemy_eshot(this, fild(1),  0, fld(0.5));
			enemy_eshot(this, fild(2),  0, fld(0.5));
			enemy_eshot(this, fild(2),  0, fld(0.5));
			enemy_eshot(this, fild(4),  0, fld(0.5));
			enemy_eshot(this, fild(4), 45, fld(0.5));
		} else {
			this->cnt = ONE_SEC * 5;
			this->step = 2;
		}
		break;
	default:
		break;
	}
}

void enemy_eshot(Task* this, fixed spd, int frame, fixed ang) {
	int i;

	if (this->wait != 0) {
		/* }ԒB */
		this->wait--;
	} else {
		/* Ge̋󂫃GgT܂B */
		for (i = 0; i < TASK_ESHOT_NUM; i++) {
			if (task_eshot[i]->flag == 0) {
				/* GeB */
				eshot_set(task_eshot[i], this->px, this->py, fadd(spd, fmul(level, spd)), ang);
				task_eshot[i]->task = this;
				this->wait = frame - fist(fimul(level, frame / 2)); /* } = frame * 1.0`0.5 */
				if (shot_eval) {
					this->wait /= 2;
				}
				break;
			}
		}
	}
}

int collision_sub(Task* this, fixed ssx, fixed ssy, fixed sex, fixed sey, fixed dsx, fixed dsy, fixed dex, fixed dey) {
	return fcom(dsx, <=, sex) &&
	       fcom(ssx, <=, dex) &&
	       fcom(dsy, <=, sey) &&
	       fcom(ssy, <=, dey);
}

void score_add(Task* this, int sc_add) {
	int flag = 0;
	score += sc_add;
	if (score < MAX_LEVEL) {
		level = fidiv(fild(score), MAX_LEVEL);
	} else {
		level = fild(1);
	}
	if (score >= high) high = score;
	switch (extend) {
	case 0:
		if (score > 200000) {
			flag = 1;
			extend++;
		}
		break;
	case 1:
		if (score > 500000) {
			flag = 1;
			extend++;
		}
		break;
	case 2:
		if (score > 1000000) {
			flag = 1;
			extend++;
		}
		break;
	default:
		break;
	}
	if (flag && game_step != 3) left++;
}


